#!/bin/bash
ORGWD=`pwd`

#Configurable Parameters
APKLOCATION=$ORGWD/apks-to-process #where the APK files are stored that should be processed

#dex2jar
#ATTENTION: if you change JAR_TARGET, you also have to change JAR_LOCATION in decompile-Mac-OSX.sh
JAR_TARGET=$ORGWD/outputs/jars #A folder to store the jars (should not exist)
DEX2JARLOCATION=$ORGWD/external-tools/dex2jar-0.0.7.11-SNAPSHOT #dex2jar location folder

########
#Normally you should not need to change anything below here
########

#Preparing for dex2jar
_classpath=""
for k in $DEX2JARLOCATION/lib/*.jar
do
 _classpath="${_classpath}:${k}"
done
DEX2JAR="java -Xms512m -Xmx1024m -classpath ${_classpath} com.googlecode.dex2jar.v3.Main"

#Look for the files to decompile
cd $APKLOCATION
FILES=`ls *.apk`

if [ -e $JAR_TARGET ]
then
    echo "[ERROR] Please remove $JAR_TARGET first!"
    exit
else
    mkdir $JAR_TARGET
fi

for f in $FILES
do
  
  echo "[INFO] dex2jar for $f"
  
  cd $DEX2JARLOCATION
  $DEX2JAR $APKLOCATION/$f
  newfilename=$DEX2JARLOCATION/${f%.apk}_dex2jar.jar
  if [ -e $newfilename ]
      then
      mv $newfilename $JAR_TARGET/
  else
      echo "[WARNING] The transformation with dex2jar did not work for: $f"
      echo "[WARNING] Could not find $newfilename"
      echo "[WARNING] The reason has to be extracted from the messages of dex2jar above"
      echo "[WARNING] Some apk simply don't work"
      echo "[WARNING] Ignoring this app for decompilation"
  fi
done

cd $ORGWD
