#Just copy a valid HTTP install request to the Google market below
#and this request will try to install the apps listed in app-list.txt
#or simply fill in YOUR_COOKIES YOUR_DEVICE and YOUR_TOKEN
request_before = """POST https://market.android.com/install HTTP/1.1
Host: market.android.com
User-Agent: Mozilla/5.0 (Macintosh; Intel Ubuntu OS X 7; rv:2.0.1) Gecko/20100101 Chrome/4.0.1
Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8
Accept-Language: de-de,de;q=0.8,en-us;q=0.5,en;q=0.3
Accept-Encoding: gzip, deflate
Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7
Keep-Alive: 115
Content-Type: application/x-www-form-urlencoded;charset=utf-8
Referer: https://market.android.com/search?q=e&c=apps&price=1&sort=0&so=1
Content-Length: 132
Cookie: YOUR_COOKIES
DNT: 1
Connection: keep-alive
Pragma: no-cache
Cache-Control: no-cache

id="""
request_after="&offerType=1&device=YOUR_DEVICE&xhr=1&token=YOUR_TOKEN"


def main():
    import time
    for line in getFileAsList('./app-list.txt'):        
        print line
        send_this_request(request_before+line+request_after)
        time.sleep(2)

def send_this_request(http_request_string, remove_headers=[], timeout=4, printDebug=False):
    """
    Always HTTP/1.1
    """
    import pprint
    import urllib2
    if remove_headers == []:
        remove_headers=['content-length', 'accept-encoding', 'accept-charset', 
        'accept-language', 'accept', 'keep-alive', 'connection', 'pragma', 
        'cache-control']
        
    for i, remove_header in enumerate(remove_headers):
        remove_headers[i] = remove_header.lower()
    
    if '\n\n' in http_request_string:
        headers, body = http_request_string.split('\n\n',1)
    else:
        headers = http_request_string
        body = None
    headers = headers.split('\n')
    request_line = headers[0]
    headers = headers[1:]
    
    method, rest = request_line.split(" ", 1)
    url, protocol = rest.rsplit(" ", 1)
    
    merge_host_header_into_url = False
    if url.startswith("http"):
        #remove_headers.append("host")
        merge_host_header_into_url = False
    elif url.startswith("/"):
        print "Warning: Defaulting to HTTP. Please write URL as https:// if you want SSL"
        merge_host_header_into_url = True
    else:
        print "ERROR: Protocol not supported. URL must start with http or /"
        exit()
    
    
    header_tuples = []
    for header in headers:
        name, value = header.split(": ", 1)
        if merge_host_header_into_url and name.lower() == 'host':
            url = 'http://'+value+url
        if not name.lower() in remove_headers:
            header_tuples.append((name, value))
            if printDebug:
                print "Added header: "+name
    
    opener = urllib2.build_opener()
    opener.addheaders = header_tuples
    urllib2.install_opener(opener)
    
    try:
        print urllib2.urlopen(url, body, timeout).read()
    except urllib2.HTTPError, e:
        print 'The server couldn\'t fulfill the request.'
        print 'Error code: ', e.code
       
    except urllib2.URLError, e:
        print "URLError:", e.reason
    except Exception, e:
        print "DIDNT WORK:", e
    if printDebug:
        print "URL: ", url
        print "HEADERS:"
        pprint.pprint(header_tuples)
        print "BODY:", body
    

def getFileAsList(filepath):
    f = open(filepath)
    lines = []    
    for line in f.readlines():        
        if line.endswith('\n'):
            line = line[:-1]
        if line.endswith('\r'):
            line = line[:-1]
        lines.append(line)
    f.close()
    return lines

    
def writeToFile(filepath, content):
    f = file(filepath,"w")
    f.write(content)
    f.close()

main()