#!/bin/bash
#For Ubuntu 11.04
echo "[INFO] Checking if packages installed"
dpkg --status autoconf | grep -q not-installed
if [ $? -eq 0 ]; then
    echo "[INFO] Apt-get installing autoconf, please provide sudo password"
    sudo apt-get install autoconf
else
    echo "[INFO] autoconf already installed, good"
fi
dpkg --status gcc-arm-linux-gnueabi | grep -q not-installed
if [ $? -eq 0 ]; then
    echo "[INFO] Apt-get installing gcc-arm-linux-gnueabi, please provide sudo password"
    sudo apt-get install gcc-arm-linux-gnueabi
else
    echo "[INFO] gcc-arm-linux-gnueabi already installed, good"
fi

CC=`which arm-linux-gnueabi-gcc`

#GingerBreak compilation
#The GingerBreak.c had to be changed a little bit, because of this problem:
#http://www.spinics.net/lists/netdev/msg171723.html
#Therefore #include <sys/socket.h> is done before #include <linux/netlink.h>
#The next problem is that we would have to include 
#the native Android API (NDK), because sys/system_properties is not included
echo "Currently this compilation is not properly implemented"
echo "Please download the Android NDK and point this compilation script"
echo "to it. Otherwise sys/system_properties is simply not found."
echo "As I don't have a GingerBread device, i couldn't have test it anyway. floyd"
$CC -static -o GingerBreak-unstripped.bin GingerBreak.c
arm-linux-gnueabi-strip -o GingerBreak.bin -s GingerBreak-unstripped.bin
rm GingerBreak-unstripped.bin
file GingerBreak.bin | grep -q ARM
#End GingerBreak compilation


if [ ! $? -eq 0 ]; then
    echo "[ERROR] Looks like the binary was incorrectly compiled with another compler than arm-linux-gnueabi-gcc"
    echo "[ERROR] The resulting binary will not run on ARM, therefore aborting!"
    exit
fi
echo "[INFO] Your binary is finished, happy hacking on ARM!"
