#!/bin/bash
#For Ubuntu 11.04
echo "[INFO] Checking if packages installed"
dpkg --status autoconf | grep -q not-installed
if [ $? -eq 0 ]; then
    echo "[INFO] Apt-get installing autoconf, please provide sudo password"
    sudo apt-get install autoconf
else
    echo "[INFO] autoconf already installed, good"
fi
dpkg --status gcc-arm-linux-gnueabi | grep -q not-installed
if [ $? -eq 0 ]; then
    echo "[INFO] Apt-get installing gcc-arm-linux-gnueabi, please provide sudo password"
    sudo apt-get install gcc-arm-linux-gnueabi
else
    echo "[INFO] gcc-arm-linux-gnueabi already installed, good"
fi

CC=`which arm-linux-gnueabi-gcc`

#exploid2 compilation
$CC -static -o exploid2-unstripped.bin exploid2.c
arm-linux-gnueabi-strip -o exploid2.bin -s exploid2-unstripped.bin
rm exploid2-unstripped.bin
file exploid2.bin | grep -q ARM
#End exploid2 compilation


if [ ! $? -eq 0 ]; then
    echo "[ERROR] Looks like the binary was incorrectly compiled with another compler than arm-linux-gnueabi-gcc"
    echo "[ERROR] The resulting binary will not run on ARM, therefore aborting!"
    exit
fi
echo "[INFO] Your binary is finished, happy hacking on ARM!"
